package com.xaxn.south.ownerloan.service.impl;

package ..deTemp.1736497322137;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.bean.copier.CopyOptions;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.xaxn.south.ownerloan.constant.LoanImageTypeEnum;
import com.xaxn.south.ownerloan.entity.FinanceLoanProduct;
import com.xaxn.south.ownerloan.entity.SouthImage;
import com.xaxn.south.ownerloan.entity.SouthOwnerLoan;
import com.xaxn.south.ownerloan.entity.SouthQrCodeInfo;
import com.xaxn.south.ownerloan.entity.dto.FinaceLoadProjectDto;
import com.xaxn.south.ownerloan.entity.dto.OwnerLoanDto;
import com.xaxn.south.ownerloan.entity.dto.ProductDto;
import com.xaxn.south.ownerloan.entity.vo.AmountScoreVo;
import com.xaxn.south.ownerloan.entity.vo.BusinessInfoVo;
import com.xaxn.south.ownerloan.entity.vo.CarImageVo;
import com.xaxn.south.ownerloan.entity.vo.IdCardInfoVo;
import com.xaxn.south.ownerloan.entity.vo.OwnerLoanDetailVo;
import com.xaxn.south.ownerloan.entity.vo.OwnerLoanVo;
import com.xaxn.south.ownerloan.entity.vo.OwnerStatusVo;
import com.xaxn.south.ownerloan.entity.vo.SouthLoanVo;
import com.xaxn.south.ownerloan.mapper.SouthOwnerLoanMapper;
import com.xaxn.south.ownerloan.service.ISouthImageService;
import com.xaxn.south.ownerloan.service.ISouthOwnerLoanService;
import com.xaxn.south.ownerloan.service.ISouthQrCodeService;
import com.xaxn.south.sys.service.ISouthOwersService;
import com.xaxn.south.utils.SysConstant;
import java.lang.invoke.SerializedLambda;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.exception.ExceptionCast;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.encryption.AesEncryptUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class SouthOwnerLoanServiceImpl extends ServiceImpl<SouthOwnerLoanMapper, SouthOwnerLoan> implements ISouthOwnerLoanService {
  @Autowired
  private ISouthImageService southImageService;
  
  @Autowired
  private ISouthOwersService owersService;
  
  @Autowired
  private ISouthQrCodeService southQrCodeService;
  
  public Page<SouthOwnerLoan> pageList(Page<SouthOwnerLoan> page, SouthOwnerLoan southOwnerLoan) {
    Page<SouthOwnerLoan> southOwnerLoanPage = (Page<SouthOwnerLoan>)((SouthOwnerLoanMapper)this.baseMapper).selectPage((IPage)page, (Wrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)(new LambdaQueryWrapper()).like(StringUtils.isNotBlank(southOwnerLoan.getName()), SouthOwnerLoan::getName, southOwnerLoan.getName())).or()).like(StringUtils.isNotBlank(southOwnerLoan.getName()), SouthOwnerLoan::getPhone, southOwnerLoan.getName())).like(StringUtils.isNotBlank(southOwnerLoan.getOwnerName()), SouthOwnerLoan::getOwnerName, southOwnerLoan.getOwnerName())).eq((southOwnerLoan.getGoodsName() != null), SouthOwnerLoan::getGoodsName, southOwnerLoan.getGoodsName())).eq((southOwnerLoan.getStatus() != null), SouthOwnerLoan::getStatus, southOwnerLoan.getStatus())).between((southOwnerLoan.getSt() != null && southOwnerLoan.getEt() != null), SouthOwnerLoan::getCreateTime, southOwnerLoan.getSt(), southOwnerLoan.getEt()));
    return southOwnerLoanPage;
  }
  
  public OwnerLoanDetailVo listDetail(Integer id) {
    List<SouthImage> southImages = this.southImageService.list((Wrapper)(new LambdaQueryWrapper()).eq(SouthImage::getLoanId, id));
    List<SouthLoanVo> list = new ArrayList<>();
    List<SouthImage> images = (List<SouthImage>)southImages.stream().filter(v -> (v.getImageType().equals(Integer.valueOf(LoanImageTypeEnum.DRIVING_LICENSE.getImageCode())) || v.getImageType().equals(Integer.valueOf(LoanImageTypeEnum.TRADING_CARD.getImageCode())))).collect(Collectors.toList());
    ((Map)images.stream().collect(Collectors.groupingBy(SouthImage::getSort))).forEach((k, v) -> {
          SouthLoanVo southLoanVo = new SouthLoanVo();
          southLoanVo.setVehiclePositiveUrl(((SouthImage)v.get(SysConstant.ZERO.intValue())).getFrontPicture());
          southLoanVo.setVehicleBackUrl(((SouthImage)v.get(SysConstant.ZERO.intValue())).getBackPicture());
          southLoanVo.setTradingCardUrl(((SouthImage)v.get(SysConstant.DEFAULT_NUM.intValue())).getFrontPicture());
          list.add(southLoanVo);
        });
    southImages.removeAll(images);
    Map<Integer, SouthImage> southImageMap = (Map<Integer, SouthImage>)southImages.stream().collect(Collectors.toMap(SouthImage::getImageType, v -> v));
    OwnerLoanDetailVo ownerLoanDetailVo = new OwnerLoanDetailVo();
    SouthOwnerLoan southOwnerLoan = (SouthOwnerLoan)((SouthOwnerLoanMapper)this.baseMapper).selectOne((Wrapper)(new LambdaQueryWrapper()).eq(SouthOwnerLoan::getId, id));
    ownerLoanDetailVo.setName(southOwnerLoan.getName());
    ownerLoanDetailVo.setIdCardPositiveUrl(((SouthImage)southImageMap.getOrDefault(Integer.valueOf(LoanImageTypeEnum.ID_CARD.getImageCode()), new SouthImage())).getFrontPicture());
    ownerLoanDetailVo.setIdCardBackUrl(((SouthImage)southImageMap.getOrDefault(Integer.valueOf(LoanImageTypeEnum.ID_CARD.getImageCode()), new SouthImage())).getBackPicture());
    ownerLoanDetailVo.setGewerbeamtUrl(((SouthImage)southImageMap.getOrDefault(Integer.valueOf(LoanImageTypeEnum.AAUM_CARD.getImageCode()), new SouthImage())).getFrontPicture());
    ownerLoanDetailVo.setPoolAssociation(((SouthImage)southImageMap.getOrDefault(Integer.valueOf(LoanImageTypeEnum.POOL_ASSOCIATION.getImageCode()), new SouthImage())).getFrontPicture());
    ownerLoanDetailVo.setSouthLoanLogs(list);
    return ownerLoanDetailVo;
  }
  
  public OwnerStatusVo getStatus() {
    LoginUser loginUser = (LoginUser)SecurityUtils.getSubject().getPrincipal();
    SouthOwnerLoan southOwnerLoan = (SouthOwnerLoan)((SouthOwnerLoanMapper)this.baseMapper).selectOne((Wrapper)(new LambdaQueryWrapper()).eq(SouthOwnerLoan::getUserId, loginUser.getId()));
    OwnerStatusVo ownerStatusVo = new OwnerStatusVo();
    if (southOwnerLoan == null)
      return ownerStatusVo; 
    ownerStatusVo.setStatus(southOwnerLoan.getStatus());
    ownerStatusVo.setAmount(southOwnerLoan.getAmount());
    ownerStatusVo.setLoanRates(southOwnerLoan.getLoanRates());
    ownerStatusVo.setRemarks(southOwnerLoan.getRemarks());
    return ownerStatusVo;
  }
  
  public void add(OwnerLoanDto ownerLoanDto) {
    LoginUser loginUser = (LoginUser)SecurityUtils.getSubject().getPrincipal();
    SouthOwnerLoan southOwnerLoan = new SouthOwnerLoan();
    southOwnerLoan.setUserId(loginUser.getId());
    southOwnerLoan.setName(ownerLoanDto.getIdCardInfoVo().getName());
    southOwnerLoan.setPhone(loginUser.getPhone());
    southOwnerLoan.setOwnerName(this.owersService.getOwersName(loginUser.getOwersId()));
    southOwnerLoan.setGoodsName(ownerLoanDto.getGoodsName());
    southOwnerLoan.setGoodsType(ownerLoanDto.getGoodsType());
    southOwnerLoan.setStatus(SysConstant.DEFAULT_NUM);
    ((SouthOwnerLoanMapper)this.baseMapper).insert(southOwnerLoan);
    List<SouthImage> list = new ArrayList<>();
    Integer loanId = southOwnerLoan.getId();
    IdCardInfoVo idCardInfoVo = ownerLoanDto.getIdCardInfoVo();
    list.add(addImages(Integer.valueOf(LoanImageTypeEnum.ID_CARD.getImageCode()), loanId, idCardInfoVo.getIdCardFront(), idCardInfoVo.getIdCardBack(), null));
    BusinessInfoVo businessInfoVo = ownerLoanDto.getBusinessInfoVo();
    list.add(addImages(Integer.valueOf(LoanImageTypeEnum.AAUM_CARD.getImageCode()), loanId, businessInfoVo.getIndustryCommerce(), null, null));
    list.add(addImages(Integer.valueOf(LoanImageTypeEnum.POOL_ASSOCIATION.getImageCode()), loanId, businessInfoVo.getPoolAssociation(), null, null));
    List<CarImageVo> carImageVos = ownerLoanDto.getCarImageVos();
    int index = 0;
    for (CarImageVo carImageVo : carImageVos) {
      index++;
      list.add(addImages(Integer.valueOf(LoanImageTypeEnum.DRIVING_LICENSE.getImageCode()), loanId, carImageVo.getDrivingPermitFront(), carImageVo.getDrivingPermitBack(), Integer.valueOf(index)));
      list.add(addImages(Integer.valueOf(LoanImageTypeEnum.TRADING_CARD.getImageCode()), loanId, carImageVo.getVehicleOperating(), null, Integer.valueOf(index)));
    } 
    this.southImageService.saveBatch(list);
  }
  
  public Result<?> addOwnerLoan(OwnerLoanVo ownerLoanVo) {
    SouthOwnerLoan southOwnerLoan = new SouthOwnerLoan();
    List<String> list = new ArrayList<>();
    if (StringUtils.isEmpty(ownerLoanVo.getOwnerName())) {
      if (ownerLoanVo.getIsExpired().equals(SysConstant.DEFAULT_NUM) || ownerLoanVo.getIsLicense().equals(SysConstant.DEFAULT_NUM))
        ExceptionCast.cast(Result.error(101, "申请条件不符")); 
      List<String> vehicleStatus = ((SouthOwnerLoanMapper)this.baseMapper).getVehicleStatus(list);
      list = (List<String>)Arrays.<String>asList(ownerLoanVo.getAsset().split(",")).stream().filter(item -> !vehicleStatus.contains(item)).collect(Collectors.toList());
      if (list.size() == SysConstant.ZERO.intValue())
        ExceptionCast.cast(Result.error(102, "车辆状态异常")); 
    } else {
      if (ownerLoanVo.getIsNotTrust().equals(SysConstant.DEFAULT_NUM) || ownerLoanVo.getIsOutstandingLoan().equals(Integer.valueOf(4)))
        ExceptionCast.cast(Result.error(101, "申请条件不符")); 
      String ownerStatus = ((SouthOwnerLoanMapper)this.baseMapper).getOwnerStatus(ownerLoanVo.getOwnerName());
      if (ownerStatus == null || ownerStatus.equals(""))
        ExceptionCast.cast(Result.error(102, "企业状态异常")); 
      Integer assetCount = ((SouthOwnerLoanMapper)this.baseMapper).getAssetCount(ownerLoanVo.getOwnerName());
      southOwnerLoan.setAsset(assetCount + "辆");
    } 
    BeanUtil.copyProperties(ownerLoanVo, southOwnerLoan, CopyOptions.create().setIgnoreNullValue(true).setIgnoreError(true));
    southOwnerLoan.setGoodsName(Integer.valueOf(StringUtils.isNotBlank(ownerLoanVo.getOwnerName()) ? 3 : 2));
    southOwnerLoan.setGoodsType(SysConstant.DEFAULT_NUM);
    String id = ownerLoanVo.getQrId();
    try {
      id = AesEncryptUtil.desEncrypt(id).trim();
    } catch (Exception e) {
      e.printStackTrace();
    } 
    SouthQrCodeInfo qrCodeInfo = (SouthQrCodeInfo)this.southQrCodeService.getOne((Wrapper)(new LambdaQueryWrapper())
        .eq(SouthQrCodeInfo::getId, id));
    southOwnerLoan.setChannelId(qrCodeInfo.getChannelId());
    List<AmountScoreVo> mapperAmount = ((SouthOwnerLoanMapper)this.baseMapper).getAmount(list, ownerLoanVo.getName(), ownerLoanVo.getOwnerName());
    if (mapperAmount.size() == SysConstant.ZERO.intValue())
      ExceptionCast.cast(Result.error(103, "车辆/企业不存在")); 
    Integer amount = Integer.valueOf(mapperAmount.stream().mapToInt(s -> Integer.parseInt(s.getAmount())).sum());
    String companyName = ((SouthOwnerLoanMapper)this.baseMapper).getHyCompany(ownerLoanVo.getOwnerName());
    if (StringUtils.isNotBlank(companyName)) {
      List<AmountScoreVo> mapperAmountHy = ((SouthOwnerLoanMapper)this.baseMapper).getAmountHy(list, ownerLoanVo.getName(), ownerLoanVo.getOwnerName());
      amount = Integer.valueOf(mapperAmountHy.stream().mapToInt(s -> Integer.parseInt(s.getAmount())).sum());
    } 
    if (StringUtils.isEmpty(ownerLoanVo.getOwnerName()) && amount.intValue() > 200000)
      amount = Integer.valueOf(200000); 
    if (amount.equals(SysConstant.ZERO))
      ExceptionCast.cast(Result.error(104, "信用分未达标")); 
    southOwnerLoan.setOwnerName((((AmountScoreVo)mapperAmount.get(0)).getOwnerName() == null) ? "" : ((AmountScoreVo)mapperAmount.get(0)).getOwnerName());
    String score = mapperAmount.stream().map(AmountScoreVo::getScore).collect(Collectors.joining(", "));
    southOwnerLoan.setScore(score);
    southOwnerLoan.setAmount(amount.toString());
    if (StringUtils.isEmpty(ownerLoanVo.getOwnerName())) {
      String asset = mapperAmount.stream().map(AmountScoreVo::getAsset).collect(Collectors.joining(", "));
      southOwnerLoan.setAsset(asset);
    } 
    SouthOwnerLoan one = (SouthOwnerLoan)getOne((Wrapper)(new LambdaQueryWrapper()).eq(SouthOwnerLoan::getName, southOwnerLoan.getName()));
    if (one != null) {
      southOwnerLoan.setId(one.getId());
      updateById(southOwnerLoan);
    } else {
      save(southOwnerLoan);
    } 
    return Result.ok(amount.toString());
  }
  
  public Page<SouthOwnerLoan> getList(Page<SouthOwnerLoan> page, SouthOwnerLoan southOwnerLoan) {
    if (StringUtils.isBlank(String.valueOf(southOwnerLoan.getGoodsName())) || southOwnerLoan.getGoodsName() == null)
      southOwnerLoan.setGoodsName(Integer.valueOf(2)); 
    if (StringUtils.isNotEmpty(southOwnerLoan.getSt()) && StringUtils.isNotEmpty(southOwnerLoan.getEt())) {
      southOwnerLoan.setSt(southOwnerLoan.getSt() + " 00:00:00");
      southOwnerLoan.setEt(southOwnerLoan.getEt() + " 23:59:59");
    } 
    return ((SouthOwnerLoanMapper)this.baseMapper).getList(page, southOwnerLoan);
  }
  
  public SouthImage addImages(Integer imageType, Integer loanId, String frontPicture, String backPicture, Integer sort) {
    SouthImage southImage = new SouthImage();
    southImage.setLoanId(loanId);
    southImage.setFrontPicture(frontPicture);
    southImage.setBackPicture(backPicture);
    southImage.setImageType(imageType);
    southImage.setSort(sort);
    return southImage;
  }
  
  public Page<FinanceLoanProduct> getLoanProductList(Page<FinanceLoanProduct> page, FinaceLoadProjectDto finaceLoadProjectDto) {
    return ((SouthOwnerLoanMapper)this.baseMapper).getLoanProductList(page, finaceLoadProjectDto);
  }
  
  public void applyProduct(ProductDto productDto) {
    Page<FinanceLoanProduct> page = new Page(1L, 1L);
    FinaceLoadProjectDto finaceLoadProjectDto = new FinaceLoadProjectDto();
    finaceLoadProjectDto.setProductId(productDto.getProductId());
    Page<FinanceLoanProduct> loanProductList = ((SouthOwnerLoanMapper)this.baseMapper).getLoanProductList(page, finaceLoadProjectDto);
    if (loanProductList.getRecords().size() > 0) {
      productDto.setProductName(((FinanceLoanProduct)loanProductList.getRecords().get(0)).getName());
      productDto.setSysOrgCode(((FinanceLoanProduct)loanProductList.getRecords().get(0)).getSysOrgCode());
      productDto.setTenantId(((FinanceLoanProduct)loanProductList.getRecords().get(0)).getTenantId());
      productDto.setDepartIds(((FinanceLoanProduct)loanProductList.getRecords().get(0)).getDepartIds());
    } 
    ((SouthOwnerLoanMapper)this.baseMapper).updateFinanceLoanAfterProduct(productDto);
  }
}
